src/Entity/MicroPost.php
<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * @ORM\Entity(repositoryClass="App\Repository\MicroPostRepository")
 * @ORM\HasLifecycleCallbacks()
 * @ORM\Table()
 */
class MicroPost
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=280)
     */
    private $text;

    /**
     * @ORM\Column(type="datetime")
     */
    private $time;

    /**
     *@ORM\ManyToOne(targetEntity="App\Entity\User", inversedBy="posts")
     *@ORM\JoinColumn(nullable=false)
     */
    private $user;

    /**
     * @ORM\ManyToMany(targetEntity="App\Entity\User", inversedBy="postsLiked")
     * @ORM\JoinTable(name="post_likes",
     *      joinColumns={@ORM\JoinColumn(name="post_id", referencedColumnName="id")},
     *      inverseJoinColumns={@ORM\JoinColumn(name="user_id", referencedColumnName="id")} 
     * )
     */
    private $likedBy;

    public function __construct()
    {
        $this->likedBy = new ArrayCollection();
    }
    /**
     * @return mixed
     */
    public function getId()
    {
       return $this->id;
    }

    /**
    * @return mixed
    */
    public function getText()
    {
       return $this->text;
    }

    /**
    * @return mixed $text
    */
    public function setText($text): void
    {
       $this->text = $text;
    }

    /**
    * @return mixed
    */
    public function getTime()
    {
       return $this->time;
    }

    /**
    * @return mixed $time
    */
    public function setTime($time): void
    {
       $this->time = $time;
    }

      /**
     * @ORM\PrePersist()
     */
    public function setTimeOnPersist(): void
    {
        $this->time = new \DateTime();
    }

    /**
    * @return User
    */
    public function getUser()
    {
       return $this->user;
    }

  
    /**
    * @return mixed $user
    */
    public function setUser($user)
    {
       $this->user = $user;
    }   

    /**
    * @return Collection
    */
    public function getLikedBy()
    {
       return $this->likedBy;
    } 

    public function like(User $user)
    {
        if ($this->likedBy->contains($user)){
            return;            
        }

        $this->likedBy->add($user);
    }

}

src/Entity/User.php
<?php

//---------------------------------------------------------------
namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Security\Core\User\AdvancedUserInterface;
use Symfony\Component\Validator\Constraints as Assert;
//---------------------------------------------------------------

/**
 * @ORM\Entity(repositoryClass="App\Repository\UserRepository")
 * @UniqueEntity(fields="email", message="This e-mail is allready in use")
 * @UniqueEntity(fields="username", message="This username is allready in use")
 */
class User implements AdvancedUserInterface, \Serializable
{
    const ROLE_USER  = 'ROLE_USER';
    const ROLE_ADMIN = 'ROLE_ADMIN';

    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=50, unique=true)
     * @Assert\NotBlank()
     * @Assert\Length(min=5, max=50)
     */
    private $username;

    /**
     * @ORM\Column(type="string")
     */
    private $password;

    /**
     * @Assert\NotBlank()
     * @Assert\Length(min=8, max=4096)
     */
    private $plainPassword;

    /**
     * @ORM\Column(type="string", length=254, unique=true)
     * @Assert\NotBlank()
     * @Assert\Email()
     */
    private $email;

    /**
     * @ORM\Column(type="string", length=50)
     * @Assert\Length(min=4, max=50)
     */
    private $fullName;

    /**
     * @var array
     * @ORM\Column(type="simple_array")
     */
    private $roles;

    /**
     * @ORM\OneToMany(targetEntity = "App\Entity\MicroPost", mappedBy="user")
     */
    private $posts;

    /**
     * @ORM\ManyToMany(targetEntity="App\Entity\MicroPost", mappedBy="likedBy")
     */
    private $postsLiked;

     /**
     * @ORM\ManyToMany(targetEntity="App\Entity\User", mappedBy="following")
     */
    private $followers;

    /**
     * @ORM\ManyToMany(targetEntity="App\Entity\User", inversedBy="followers")
     * @ORM\JoinTable(name="following", 
     *      joinColumns={
     *          @ORM\JoinColumn(name="user_id", referencedColumnName="id")
     *      },
     *      inverseJoinColumns={
     *          @ORM\JoinColumn(name="following_user_id", referencedColumnName="id")
     *      } )
     */ 
    private $following;

    /**
     * @ORM\Column(type="string", nullable=true, length=30)
     */
    private $confirmationToken;

    /**
     * @ORM\Column(type="boolean")
     */
    private $enabled;

    /**
     * @ORM\OneToOne(targetEntity="App\Entity\UserPreferences", cascade={"persist"})
     */
    private $preferences;


    public function __construct()
    {
        $this->posts        = new ArrayCollection();
        $this->followers    = new ArrayCollection();
        $this->following    = new ArrayCollection();
        $this->postsLiked   = new ArrayCollection();
        $this->roles = [self::ROLE_USER];
        $this->enabled = false;
    }

    public function getRoles()
    {
        return $this->roles;
    }

    /**
     * @return mixed 
     */
    public function getId()
    {
        return $this->id;
    }

    public function getPassword()
    {
        return $this->password;
    }

    /**
     * @return mixed
     */
    public function getPlainPassword()
    {
        return $this->plainPassword;
    }

    public function getSalt()
    {
        return null;
    }

    public function getUsername()
    {
        return $this->username;
    }

    /**
     * @return mixed 
     */
    public function getFullname()
    {
        return $this->fullName;
    }

    /**
     * @return mixed 
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * @return mixed
     */
    public function getPosts()
    {
        return $this->posts;
    }

    /**
     * @return mixed
     */
    public function getFollowers()
    {
        return $this->followers;
    }

    /**
     * @return mixed
     */
    public function getFollowing()
    {
        return $this->following;
    }

    /**
     * @param array $roles 
     */
    public function setRoles(array $roles): void
    {
        $this->roles = $roles;
    }

    /**
     * @param mixed $password 
     */
    public function setPassword($password): void
    {
        $this->password = $password;
    }

    /**
     * @return mixed $plainPassword
     */
    public function setPlainPassword($plainPassword): void
    {
        $this->plainPassword = $plainPassword;
    }

    /**
     * @param mixed $email
     */
    public function setEmail($email): void
    {
        $this->email = $email;
    }

    /**
     * @param mixed $userName 
     */
    public function setUsername($username): void
    {
        $this->username = $username;
    }
   
    /**
     * @param mixed $fullName 
     */
    public function setFullname($fullName): void
    {
        $this->fullName = $fullName;
    }
   
    /**
     * @return Collection
     */
    public function getPostsLiked()
    {
        return $this->postsLiked;
    }

    public function eraseCredentials()
    {
        //TODO: Implement eraseCredentials() method.
    }

    public function serialize()
    {
        return serialize([
            $this->id,
            $this->username,
            $this->password,
            $this->enabled
        ]);
    }

    public function unserialize($serialized)
    {
        list (
            $this->id,
            $this->username,
            $this->password, 
            $this->enabled
        ) = unserialize($serialized) ;
    }

    /**
     * @return mixed
     */
    public function getConfirmationToken()
    {
        return $this->confirmationToken;
    }

    /**
     * @param mixed $confirmationToken
     */
    public function setConfirmationToken($confirmationToken)
    {
        $this->confirmationToken = $confirmationToken;
    }

    /**
     * @return mixed
     */
    public function getEnabled()
    {
        return $this->enabled;
    }

    /**
     * @param mixed $enabled
     */
    public function setEnabled($enabled)
    {
        $this->enabled = $enabled;
    }


    public function isAccountNonExpired()
    {
        return true;
    }
    
    
    public function isAccountNonLocked()
    {
        return true;
    }

   
    public function isCredentialsNonExpired()
    {
        return true;
    }

    
    public function isEnabled()
    {
        return $this->enabled;
    }



    /**
     * @return UserPrefernces\null
     */
    public function getPreferences()
    {
        return $this->preferences;
    }

    /**
     * @param mixed $preferences
     */
    public function setPreferences($preferences): void
    {
        $this->preferences = $preferences;
    }
}

src/Form/MicroPostType.php
<?php 

//------------------------------------------------------------------

namespace App\Form;

use App\Entity\MicroPost;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

//-------------------------------------------------------------------

/**
 * 
 */
class MicroPostType extends AbstractType
{
	// overriding two methods from the parent class..

	public function buildForm(FormbuilderInterface $builder, array $options)
	{
		$builder->add('text', TextareaType::class, ['label'=> false])->add('save', SubmitType::class);
	}

	public function configureOptions(OptionsResolver $resolver)
	{
		$resolver->setDefaults([
			'data_class' => MicroPost::class
		]);
	}

}

src/Controller/MicroPostController.php
<?php

namespace App\Controller;

use App\Entity\MicroPost;
use App\Entity\User;
//use App\controller\FollowingController;
use App\Form\MicroPostType;
use App\Repository\MicroPostRepository;
use App\Repository\UserRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\Form\FormFactoryInterface;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Security;
use Symfony\Component\HttpFoundation\Session\Flash\FlashBagInterface;
use Symfony\Component\Routing\RouterInterface;
use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorageInterface;
use Symfony\Component\Security\Core\Authorization\AuthorizationCheckerInterface;
use twig_Environment;


/**
 *@Route("/micro-post")
 */

class MicroPostController {
	/**
	 *@var Twig_environment
	 */
	private $twig;

	/**
	 *@var MicroPostRepository
	 */
	private $microPostRepository;

	/**
	 *@var UserRepository
	 */
	private $userRepository;

	/**
	 * @var FormFactoryInterface
	 */
	private $formFactory;

	/**
	 * @var EntityManagerInterface
	 */
	private $entityManager;

	/**
	 * @var RouterInterface
	 */
	private $router;

	/**
	 * @var FlashBagInterface
	 */
	private $flashBag;

	/**
	 * @var AuthorizationCheckerInterface
	 */
	private $authorizationChecker;

    /**
     * @param twig_Environment $twig
     * @param MicroPostRepository $microPostRepository
     * @param UserRepository $userRepository
     * @param FormFactoryInterface $formFactory
     * @param EntityManagerInterface $entityManager
     * @param RouterInterface $router
     * @param FlashBagInterface $flashBag
     * @param AuthorizationCheckerInterface $authorizationChecker
     */
	public function __construct(
		Twig_Environment $twig,
		MicroPostRepository $microPostRepository,
		UserRepository $userRepository,
		FormFactoryInterface $formFactory,
		EntityManagerInterface $entityManager,
		RouterInterface $router,
		FlashBagInterface $flashBag,
		AuthorizationCheckerInterface $authorizationChecker
	) {

		$this->twig                 = $twig;
		$this->microPostRepository  = $microPostRepository;
		$this->userRepository       = $userRepository;
		$this->formFactory          = $formFactory;
		$this->entityManager        = $entityManager;
		$this->router               = $router;
		$this->flashBag             = $flashBag;
		$this->authorizationChecker = $authorizationChecker;
	}

    /**
     * @Route("/", name="micro_post_index")
     * @param TokenStorageInterface $tokenStorage
     * @param UserRepository $userRepository
     * @return Response
     * @throws \Twig_Error_Loader
     * @throws \Twig_Error_Runtime
     * @throws \Twig_Error_Syntax
     */
	public function index(TokenStorageInterface $tokenStorage, UserRepository $userRepository): Response
    {
		$currentUser   = $tokenStorage->getToken()->getUser();
		$usersToFollow = [];

		if ($currentUser instanceof User){
			$posts = $this->microPostRepository->findAllByUsers(
				$currentUser->getFollowing()
			);

			$usersToFollow = count($posts) === 0?
			$userRepository->findAllWithMoreThan5PostsExceptUser($currentUser): [];

		} else {

			$posts = $this->microPostRepository->findby(
				[],
				['time' => 'DESC']
			);
		}

		$html = $this->twig->render(
			'micro-post/index.html.twig',
			[
				'posts' 		=> $posts,
				'usersToFollow' => $usersToFollow
			]
		);

		return new Response($html);
	}

	/**
	 *@Route("/edit/{id}", name="micro_post_edit")
	 *@Security("is_granted('edit', microPost)", message="Access denied")
	 */
	//Using param converter used in the argument of the method that uses the route to define the micropost id.
	public function edit(MicroPost $microPost, Request $request) 
	{
		//$this->denyUnlessGranted('edit', $microPost); --Requires the controller to extend symfony bass Controller--

		$form = $this->formFactory->create(MicroPostType::class , $microPost);
		$form->handleRequest($request);

		if ($form->isSubmitted() && $form->isValid()) {
			$this->entityManager->persist($microPost);
			$this->entityManager->flush();

			return new RedirectResponse(
				$this->router->generate('micro_post_index')
			);
		}

		return new Response(
			$this->twig->render(
				'micro-post/add.html.twig',
				['form' => $form->createView()]
			)
		);
	}

	/**
	 *@Route("/delete/{id}", name="micro_post_delete")
	 *@Security("is_granted('delete', microPost)", message="Access denied")
	 */
	public function delete(MicroPost $microPost) 
	{
		$this->entityManager->remove($microPost);
		$this->entityManager->flush();

		$this->flashBag->add('notice', 'Micro Post was deleted');

		return new RedirectResponse(
			$this->router->generate('micro_post_index')
		);
	}

    /**
     * @Route("/add", name="micro_post_add")
     * @Security("is_granted('ROLE_USER')")
     * @param Request $request
     * @param TokenStorageInterface $tokenStorage
     * @return RedirectResponse|Response
     * @throws \Twig_Error_Loader
     * @throws \Twig_Error_Runtime
     * @throws \Twig_Error_Syntax
     */
	public function add(Request $request, TokenStorageInterface $tokenStorage) 
	{
		$user = $tokenStorage->getToken()->getUser();

		$microPost = new MicroPost();
		$microPost->setUser($user);

		$form = $this->formFactory->create(MicroPostType::class , $microPost);
		$form->handleRequest($request);

		if ($form->isSubmitted() && $form->isValid()) {
			$this->entityManager->persist($microPost);
			$this->entityManager->flush();

			$this->flashBag->add('notice', 'Micro Post created');

			return new RedirectResponse(
				$this->router->generate('micro_post_index')
			);
		}

		return new Response(
			$this->twig->render('micro-post/add.html.twig', ['form' => $form->createView()])
		);
	}
	/**
	 * @Route ("/user/{username}", name="micro_post_user")
	 */
	public function userPosts(User $userWithPosts) 
	{
		$html = $this->twig->render(
			'micro-post/user-posts.html.twig',
			[
				'posts'  => $this->microPostRepository->findby(
					['user' => $userWithPosts],
					['time' => 'DESC']
				),
				'user' => $userWithPosts,
				// or can do it like this
				// 'posts'=> $userWithPosts->getPosts()
			]
		);

		return new Response($html);
	}

    /**
     * @Route("/{id}", name="micro_post_post")
     * @param MicroPost $post
     * @return Response
     * @throws \Twig_Error_Loader
     * @throws \Twig_Error_Runtime
     * @throws \Twig_Error_Syntax
     */
	public function post(MicroPost $post): Response
    {
		//line bellow not neede becasuse of param converter used in the argument above.
		//$post = $this->microPostRepository->find($id);

		return new Response(
			$this->twig->render('micro-post/post.html.twig', ['post' => $post])
		);
	}

}

templates/micro-post/add.html.twig
{% extends 'base.html.twig' %}

	{% block body %}

		{{ form_start(form) }}
		{{ form_widget(form) }}
		{{ form_end(form) }}

    {% endblock %}

templates/micro-post/index.html.twig
{% extends 'base.html.twig'%}
    
{% block body %}

	{% for message in app.flashes('notice') %}
		<div class="alert alert-success">
			{{ message }}			
		</div>	    
	{% endfor %}	

	{% if usersToFollow|length > 0 %}
		<p>You look lonely... How about some company ?</p>

		{% for userToFollow in usersToFollow %}
			<a href="{{ path('following_follow', {'id': userToFollow.id}) }}">
			 @{{ userToFollow.username }},</a>		    
		{% endfor %}

	{% endif %}

    <h6 class="border-bottom border-gray pb-2 mb-0">Recent updates</h6>
	
	{% for post in posts %}
		
		{{ include('micro-post/raw-post.html.twig', { 'post': post }) }}
		
		<small class="d-block text-right mt-3">
			{% if is_granted('edit', post) %}
            	<a href="{{ path('micro_post_edit', { 'id': post.id }) }}">Edit</a>
            {% endif %}
            {% if is_granted('delete', post) %}
            	<a href="{{ path('micro_post_delete', { 'id': post.id }) }}">Delete</a>
            {% endif %}
    	</small>
    	
	{% endfor %}

{% endblock %}

templates/micro-post/post.html.twig
{% extends 'base.html.twig'%}

{% block body %}
    
	{{ include('micro-post/raw-post.html.twig', { 'post': post }) }}
	
	{% set isLiked = post.getLikedBy.contains(app.user) %}

		<div class="pt-2">
			<button id="like" class="btn btn-outline-secondary btn-sm" style="display: {% if not isLiked %}block{% else %}none{% endif %}">Like
				<span id="likes-like" class="badge badge-light">{{ post.getLikedBy.count }}</span>
			</button>

			<button id="unlike" class="btn btn-outline-danger btn-sm" style="display: {% if isLiked %}block{% else %}none{% endif %}">Unlike
				<span id="likes-unlike" class="badge badge-light">{{ post.getLikedBy.count }}</span>
			</button>

		</div>
{% endblock %} 


{% block javascripts %}

	{{ parent() }}

	<script>
		var	likeButton = document.getElementById('like');
		var	unlikeButton = document.getElementById('unlike');

		addOnClick(
			likeButton,
			unlikeButton,
			document.getElementById('likes-unlike'),
			'{{ path('likes_like', {'id': post.id}) }}'
		);

		addOnClick(
			unlikeButton,
			likeButton,
			document.getElementById('likes-like'),
			'{{ path('likes_unlike', {'id': post.id}) }}'
		);

		function switchButtons(button, oppositeButton) {
			button.style.display = 'none';
			oppositeButton.style.display = 'block';
		}

		function addOnClick(button, oppositeButton, likeCount, path) {
			button.addEventListener('click', function(event) {
				{% if not app.user %}
					return window.location.replace('{{ path('user_register')}}')
				{% endif %}
				button.disabled = true;
				fetch(path, {'credentials': 'include'}).then(function (response) {
					response.json().then(function (json) {
						likeCount.innerText = json.count;
						switchButtons(button, oppositeButton);
					})
				}).catch(function () {
					switchButtons(button,oppositeButton);
				});

				event.preventDefault();
			});

		}
	</script>
    
{% endblock %}

templates/micro-post/raw-post.html.twig
{% block body %}
  
<div class="media text-muted pt-3">
	{% set initials = post.user.fullName|split('') %}  
    <img data-src="holder.js/32x32?text={{ attribute(initials, 0)|first }}{{ attribute(initials, 1)|first }}&bg=e83e8c&fg=fff&size=8" alt="" class="mr-2 rounded">
    <p class="media-body pb-3 mb-0 small lh-125 border-bottom border-gray">
	    <span class="d-block">
	    	<a href="{{ path('micro_post_user', {'username': post.user.username}) }}">
	    		<strong class="text-gray-dark">{{ post.user.username }}</strong>
	    	</a>
	       	<small>{{ post.time|date("d/m/y") }}</small>
	    </span>	    
	    <a href="{{ path('micro_post_post', { 'id': post.id }) }}">{{ post.text }}</a>
    </p>
</div>


{% endblock %} 

templates/micro-post/user-posts.html.twig
{% extends 'base.html.twig'%}
    
{% block body %}
	<div class="card-group py-2">
		<div class="card">
			<div class="card-body">
				<h5 class="card-title">
					{{ user.fullname }}
					<small class="testmuted"></small>· @{{ user.username }}</small>
				</h5>
                {% if is_granted('ROLE_USER') and user != app.user  %}
                    {% if user.followers.contains(app.user) == false %}
                        <a href="{{ path('following_follow', {'id' : user.id}) }}" class="btn btn-outline-primary">Follow</a>
                    {% else %}
                        <a href="{{ path('following_unfollow', {'id' : user.id}) }}" class="btn btn-outline-danger">UnFollow</a>                     
                    {% endif %}
                {% endif %}
			</div>
		</div>
	</div>

	<div class="card-group py-2">
        <div class="card">
            <div class="card-body">
                <h5>{{ 'Followers'|transchoice(user.followers|length) }}</h5>
            </div>
            <ul class="list-group list-group-flush">
                {% for follower in user.followers %}
                    <li class="list-group-item">
                        <a href="{{ path('micro_post_user', {'username': follower.username}) }}">
                            @{{ follower.username }}
                        </a>
                    </li>
                {% endfor %}
            </ul>
        </div>	
        <div class="card">
            <div class="card-body">
                <h5>{{ 'Following'|transchoice(user.following|length) }}</h5>
            </div>
            <ul class="list-group list-group-flush">
                {% for following in user.following %}
                    <li class="list-group-item">
                        <a href="{{ path('micro_post_user', {'username': following.username}) }}">
                            @{{ following.username }}
                        </a>
                    </li>
                {% endfor %}
            </ul>
        </div>
	</div>

	{% for post in posts %}
		
		{{ include('micro-post/raw-post.html.twig', { 'post': post }) }}
		
		<small class="d-block text-right mt-3">
			{% if is_granted('edit', post) %}
            	<a href="{{ path('micro_post_edit', { 'id': post.id }) }}">Edit</a>
            {% endif %}
            {% if is_granted('delete', post) %}
            	<a href="{{ path('micro_post_delete', { 'id': post.id }) }}">Delete</a>
            {% endif %}
    	</small>
    	
	{% endfor %}


{% endblock %}